{$D-,L-,O+,Q-,R-,Y-,S-,I-}
unit Builder;

interface

uses
    Windows,
    SysUtils,
    Classes,
    Controls,
    Forms,
    Dialogs,
    StdCtrls,
    ExtCtrls,
    ComCtrls,
    XPMan,
    ShellAPI;

type
  TfrmSparkleBuilder = class(TForm)
    odlHeading: TOpenDialog;
    odlReadMe: TOpenDialog;
    odlAbout: TOpenDialog;
    odlMovie: TOpenDialog;
    odlOutput: TOpenDialog;
    btnBuild: TButton;
    btnCancel: TButton;
    pgcPageControl: TPageControl;
    tstPaths: TTabSheet;
    lblSpatkle: TLabel;
    lblReadMe: TLabel;
    lblAbout: TLabel;
    lblMovie: TLabel;
    edtSparkle: TEdit;
    btnHeading: TButton;
    edtReadMe: TEdit;
    btnReadMe: TButton;
    edtAbout: TEdit;
    btnAbout: TButton;
    edtMovie: TEdit;
    btnMovie: TButton;
    tstCaptions: TTabSheet;
    lblInstallWindowCaption: TLabel;
    lblUninstallWindowCaption: TLabel;
    lblCreateDesktopShortcutCaption: TLabel;
    lblUninstallWindowText: TLabel;
    lblPreviewButtonCaption: TLabel;
    lblInstallButtonCaption: TLabel;
    lblAboutWindowCaption: TLabel;
    lblCancelButtonCaption: TLabel;
    lblOKButtonCaption: TLabel;
    edtInstallWindowCaption: TEdit;
    edtUninstallWindowCaption: TEdit;
    edtCreateDesktopShortcutCaption: TEdit;
    edtUninstallWindowText: TEdit;
    edtPreviewButtonCaption: TEdit;
    edtInstallButtonCaption: TEdit;
    edtAboutWindowCaption: TEdit;
    edtCancelButtonCaption: TEdit;
    edtOKButtonCaption: TEdit;
    pgcOutput: TPageControl;
    tstOutput: TTabSheet;
    lblOutput: TLabel;
    edtOutput: TEdit;
    btnOutput: TButton;
    chkTranslateCaptions: TCheckBox;
    xpmXPManifest: TXPManifest;
    lblUnlockCode: TLabel;
    edtUnlockCode: TEdit;
    btnUnlockCode: TButton;
    procedure FormCreate(Sender: TObject);
    procedure chkTranslateCaptionsClick(Sender: TObject);
    procedure btnBuildClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure btnHeadingClick(Sender: TObject);
    procedure btnReadMeClick(Sender: TObject);
    procedure btnAboutClick(Sender: TObject);
    procedure btnMovieClick(Sender: TObject);
    procedure btnOutputClick(Sender: TObject);
    procedure btnUnlockCodeClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmSparkleBuilder: TfrmSparkleBuilder;

implementation

{$R *.dfm}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
procedure FileChoice(OpenDialog : TOpenDialog; Edit : TEdit);
begin
     OpenDialog.FileName := Edit.Text;
     OpenDialog.InitialDir := ExtractFilePath(OpenDialog.FileName);
     if OpenDialog.Execute then
        begin
             Edit.Text := OpenDialog.FileName;
        end;
end;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
procedure TfrmSparkleBuilder.FormCreate(Sender: TObject);
var
   S : String;
begin
     // "..\.." directory path + 'Install\DLL\'
     S := ExtractFilePath(ExcludeTrailingPathDelimiter(ExtractFilePath(ExcludeTrailingPathDelimiter(ExtractFilePath(Application.ExeName))))) + 'Install\DLL\';

     edtSparkle.Text := S + 'Sparkle.dll';

     // ".." directory path 
     S := ExtractFilePath(ExcludeTrailingPathDelimiter(ExtractFilePath(Application.ExeName)));
     edtReadMe.Text  := S + 'ReadMe.rtf';
     edtAbout.Text   := S + 'About.rtf';
     edtMovie.Text   := S + 'Movie.swf';
     edtOutput.Text  := S + 'ScreenSaver.exe';

     chkTranslateCaptionsClick(chkTranslateCaptions);
end;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
procedure TfrmSparkleBuilder.chkTranslateCaptionsClick(Sender: TObject);
begin
     tstCaptions.Enabled := chkTranslateCaptions.Checked;
     tstCaptions.Visible := tstCaptions.Enabled;
     tstCaptions.TabVisible := tstCaptions.Enabled;
     if tstCaptions.Enabled then
        begin
             pgcPageControl.ActivePage := tstCaptions;
        end;
end;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
procedure TfrmSparkleBuilder.btnHeadingClick(Sender: TObject);
begin
     FileChoice(odlHeading, edtSparkle);
end;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
procedure TfrmSparkleBuilder.btnReadMeClick(Sender: TObject);
begin
     FileChoice(odlReadMe, edtReadMe);
end;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
procedure TfrmSparkleBuilder.btnAboutClick(Sender: TObject);
begin
     FileChoice(odlAbout, edtAbout);
end;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
procedure TfrmSparkleBuilder.btnMovieClick(Sender: TObject);
begin
     FileChoice(odlMovie, edtMovie);
end;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
procedure TfrmSparkleBuilder.btnOutputClick(Sender: TObject);
begin
     FileChoice(odlOutput, edtOutput);
end;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
procedure TfrmSparkleBuilder.btnBuildClick(Sender: TObject);
type
    TBuildScreenSaver   = function (
                                    var
                                    Output,
                                    ReadMeText,
                                    AboutText,
                                    MovieName
                                   ) : Bool; stdcall;

    TBuildScreenSaverEx = function (
                                    var
                                    Output,
                                    ReadMeText,
                                    AboutText,
                                    MovieName,
                                    InstallWindowCaption,
                                    CreateDesktopShortcutCaption,
                                    PreviewButtonCaption,
                                    InstallButtonCaption,
                                    CancelButtonCaption,
                                    UninstallWindowCaption,
                                    UninstallWindowText,
                                    AboutWindowCaption,
                                    OKButtonCaption              : PChar
                                   ) : Bool; stdcall;

    TRegister = procedure (var Code : PChar); stdcall;
    
const
     cBuildScreenSaver   = 'BuildScreenSaver';
     cBuildScreenSaverEx = 'BuildScreenSaverEx';
     cRegister           = 'Register';

var
   H : LongWord;
   BuildScreenSaverPtr : Pointer;

   UnlockCode,

   Output,
   ReadMeText,
   AboutText,
   MovieName,
   InstallWindowCaption,
   CreateDesktopShortcutCaption,
   PreviewButtonCaption,
   InstallButtonCaption,
   CancelButtonCaption,
   UninstallWindowCaption,
   UninstallWindowText,
   AboutWindowCaption,
   OKButtonCaption              : PChar;

   Done                         : Boolean;

begin

     Done  := False;

     H := LoadLibrary(PChar(edtSparkle.Text));
     if H <> 0 then
        begin
             // Unlock your copy of the library:
             BuildScreenSaverPtr := GetProcAddress( H, cRegister );
             if (BuildScreenSaverPtr <> nil) then
                begin
                     UnlockCode := PChar(edtUnlockCode.Text);
                     TRegister( BuildScreenSaverPtr ) ( UnlockCode );
                end;

             // Create screen saver!
             Output                       := PChar(edtOutput.Text);
             ReadMeText                   := PChar(edtReadMe.Text);
             AboutText                    := PChar(edtAbout.Text);
             MovieName                    := PChar(edtMovie.Text);
             InstallWindowCaption         := PChar(edtInstallWindowCaption.Text);
             CreateDesktopShortcutCaption := PChar(edtCreateDesktopShortcutCaption.Text);
             PreviewButtonCaption         := PChar(edtPreviewButtonCaption.Text);
             InstallButtonCaption         := PChar(edtInstallButtonCaption.Text);
             CancelButtonCaption          := PChar(edtCancelButtonCaption.Text);
             UninstallWindowCaption       := PChar(edtUninstallWindowCaption.Text);
             UninstallWindowText          := PChar(edtUninstallWindowText.Text);
             AboutWindowCaption           := PChar(edtAboutWindowCaption.Text);
             OKButtonCaption              := PChar(edtOKButtonCaption.Text);

             if chkTranslateCaptions.Checked then
                begin
                     BuildScreenSaverPtr := GetProcAddress( H, cBuildScreenSaverEx );
                     if (BuildScreenSaverPtr <> nil) then
                        begin
                             Done :=
                             TBuildScreenSaverEx( BuildScreenSaverPtr ) (
                                                                         Output,
                                                                         ReadMeText,
                                                                         AboutText,
                                                                         MovieName,
                                                                         InstallWindowCaption,
                                                                         CreateDesktopShortcutCaption,
                                                                         PreviewButtonCaption,
                                                                         InstallButtonCaption,
                                                                         CancelButtonCaption,
                                                                         UninstallWindowCaption,
                                                                         UninstallWindowText,
                                                                         AboutWindowCaption,
                                                                         OKButtonCaption
                                                                         );
                        end;
                end
             else
                 begin
                      BuildScreenSaverPtr := GetProcAddress( H, cBuildScreenSaver );
                      if (BuildScreenSaverPtr <> nil) then
                         begin
                              Done :=
                              TBuildScreenSaver  ( BuildScreenSaverPtr ) (
                                                                          Output,
                                                                          ReadMeText,
                                                                          AboutText,
                                                                          MovieName
                                                                          );
                         end;
                 end;
             FreeLibrary(H);

             if Done then
                begin
                     Close;
                     WinExec(PChar(edtOutput.Text), SW_SHOW);
                end
             else
                 begin
                      if not FileExists(ReadMeText) then
                         begin
                              ShowMessage('File is missing:' + #13#10 + ReadMeText );
                         end;
                      if not FileExists(MovieName) then
                         begin
                              ShowMessage('File is missing:' + #13#10 + MovieName );
                         end;
                      if not FileExists(MovieName) then
                         begin
                              ShowMessage('File is missing:' + #13#10 + MovieName );
                         end;

                      ShowMessage('Could not create output file:'+ #13#10 + Output);

                 end;
        end;
end;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
procedure TfrmSparkleBuilder.btnCancelClick(Sender: TObject);
begin
     Close;
end;

procedure TfrmSparkleBuilder.btnUnlockCodeClick(Sender: TObject);
begin
     ShellExecute(Handle, 'open', PChar( (Sender as TControl).Hint ), nil, nil, SW_SHOWNORMAL);
end;

end.
